// ================ MSP430F1xxx A/D10 ͸  ǥ ==================
//  CPU : MSP430F1232
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : IAR-MSP430
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(4.8MHz)
//            SMCLK: DCO(4.8MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include "msp430x12x2.h"
#include <stdio.h>

// Լ 
void cpu_setup(void);						// CPU ʱȭ

void adc10_set(void);						// ADC10 
void com_set(long baud);					//  
int putchar(int c);						// printf() Լ ϱ  Լ
void putchar_0(unsigned char datac);				//  1Ʈ ۽
void puts_0(unsigned char dbuf[]);				//  ڿ 

//  
unsigned char com0_rx_data;					// UART0  
int com0_rx_eflg = 0;						// UART0  ͷƮ Ϸ ÷

unsigned adc10_data;						// analog10 interrupt data
int adc10_int_flg = 0;						// analog10 interrupt flag

// ===============================  α׷ ==============================
// [μ]: void
// [] UART ACLK(32.768KHz) 
//        A/D Input 10Bit A0(P2.0) : 0 - AVcc(Է ) 
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();						// cpuʱȭ
	adc10_set();						// ADC10 
	com_set(9600);						//  
	_EINT();						// Enable interrupts

	printf("Analog Input A0(P2.0) test\r\n");
	printf("'1' : AD CH0 Dqata Read   \r\n");
	while(1){
		if(com0_rx_eflg){				// UART1  Ϸ
			if(com0_rx_data == '1'){
				adc10_int_flg = 0;
				ADC10CTL0 |= ENC + ADC10SC;	// Sampling and conversion start
				while(adc10_int_flg == 0);	// a/d conversion Ϸ 
				printf("ad_data : %x\r\n",adc10_data);//  ȭ ǥ				
			}
			else putchar_0(com0_rx_data);		// ۽
			com0_rx_eflg = 0;			// ͷƮ ÷ Clear
		}
	}
}

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned dly;

	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000U; dly++) ;			// XTAL  ð 
	
// Rsel = 7, DCO = 7, MOD = 0, DCOR = 0 TA = 25 :: DCO ִ ļ (4.4 - 5.4Mhz)
// XTX  : Low Freqency
// DIVx : ACLK = LXFTCLK(32.768KHz)
// Register Select : 7
	BCSCTL1 = XT2OFF + RSEL2 + RSEL1 + RSEL0;
	DCOCTL = 0xe0;						// DCO Max Freqency
}

// ============================== ADC10  ==================================
// [μ] void
// ----------------------------------------------------------------------------
void adc10_set(void)
{
// Input Channel : a0
// ADC10 Clock divider : /4	
	ADC10CTL1 = INCH_0+ADC10DIV_3;				// A0 for ADC10CLK/4   
// SREFx     : VR+ = AVcc, VR- = AVss
// ADC10SHTx : 16 * ADC1-CLKs
// ADC10SR   : ~200ksps
// REF2.5V   : 1.5V
// REFON     : Reference off 
// ADC10ON   : ADC10 on
// ADC10IE   : interrupt enable
	ADC10CTL0 = ADC10SHT_2 + ADC10ON + ADC10IE;		// ADC10ON, interrupt enabled
// Analog Input Enable
// ADCAE0 - 7
	ADC10AE |= 0x01;					// P2.0 ADC option select 
}

// ================================   =================================
// [μ] long baud
// Item1: Ʈ (300 - 9600Bps)
// [] ACLK(32.768KHz)
// ----------------------------------------------------------------------------
void com_set(long baud)
{
// UART Mode,8Bit Data, NON Parity, 1 STOP
	UCTL0 = CHAR;
	UTCTL0 = SSEL0;						// Source Clock UCLK = ACLK
	switch(baud){
		case 1200: UBR00 = 0x1b;			// Baud Rate Register Low
			   UBR10 = 0x00;			// Baud Rate Register High
			   UMCTL0 = 0x03;			// Modulation Control Register
			   break;
		case 2400: UBR00 = 0x0d;			// Baud Rate Register Low
			   UBR10 = 0x00;			// Baud Rate Register High
			   UMCTL0 = 0x6b;			// Modulation Control Register
			   break;
		case 4800: UBR00 = 0x06;			// Baud Rate Register Low
			   UBR10 = 0x00;			// Baud Rate Register High
			   UMCTL0 = 0x6f;			// Modulation Control Register
			   break;
		case 9600: UBR00 = 0x03;			// Baud Rate Register Low
			   UBR10 = 0x00;			// Baud Rate Register High
			   UMCTL0 = 0x4a;			// Modulation Control Register
			   break;
	}
	ME2 |= UTXE0 + URXE0;					// Enabled USART0 TXD/RXD
	IE2 |= URXIE0;						// Enabled USART0 RX interrupt
	P3SEL |= 0x30;						// P3.4,5 = USART0 TXD/RXD
}

// =============================== 1 Ʈ ۽ ==============================
// [μ] int c
// Item1:  (0 - ffh)
// [] printf()Լ  putchar() .
// ----------------------------------------------------------------------------
int putchar(int c)
{
	while(!(IFG2 & UTXIFG0));				// USART0 TX buffer ready?
	TXBUF0 = c;						// RXBUF0 = send data
	return(c);
}

// =============================== 1Ʈ ۽ ===============================
// [μ] unsigned char datac
// Item1:  (0 - ffh)
// ----------------------------------------------------------------------------
void putchar_0(unsigned char datac)
{
	while(!(IFG2 & UTXIFG0));				// USART0 TX buffer ready?
	TXBUF0 = datac;						// RXBUF0 = send data
}

// ================================ Ʈ ۽ ===============================
// [μ] unsigned char dbuf
// Item1:   ڿ
// ----------------------------------------------------------------------------
void puts_0(unsigned char dbuf[])
{
unsigned char ch;
int i = 0;

	ch = dbuf[i++];
	while(ch != 0){
		putchar_0(ch);					// 1 send
		ch = dbuf[i++];
	}
}

// ============================== UART0 interrupt =============================
// [μ] void
// ----------------------------------------------------------------------------
#pragma vector=UART0RX_VECTOR
__interrupt void usart0_rx (void)
{
	com0_rx_data = RXBUF0;					//   
	com0_rx_eflg = 1;					//  Ϸ ÷ SET
}

// ============================== ADC10 interrupt =============================
// [μ] void
// ----------------------------------------------------------------------------
#pragma vector=ADC10_VECTOR
__interrupt void ADC10_ISR (void)
{
	adc10_data = ADC10MEM;					// Move results, IFG is cleared
	adc10_int_flg = 1;					// a/d data flag on
}
