// ================== MSP430F1xxx A/D10 ͸ LED ǥ ===================
//  CPU : MSP430F1232
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : mspgcc+Dev-C++
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(4.8MHz)
//            SMCLK: DCO(4.8MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include <io.h>
#include <stdio.h>
#include <signal.h>
#include <iomacros.h>

// Լ 
void cpu_setup(void);						// CPU ʱȭ
void adc10_set(void);						// ADC10 

//  
volatile unsigned adc10_data;					// analog10 interrupt data
volatile int adc10_int_flg = 0;					// analog10 interrupt flag

// ===============================  α׷ ==============================
// [μ]: void
// [] A/D Input 10Bit A0(P2.0) : 0 - AVcc(Է ) 
//        A0 > 1.498V(465) -> LED(P1.0 = 0) ON
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();						// cpuʱȭ
	adc10_set();						// ADC10 
	P1DIR |= 0x01;						// Set P1.0 to output direction
	P1OUT |= 0x01;						// P1.0 = 0 :: LED OFF
	_EINT();						// Enable interrupts

	while(1){
		adc10_int_flg = 0;
		ADC10CTL0 |= ENC + ADC10SC;			// Sampling and conversion start
		while(adc10_int_flg == 0);			// a/d conversion Ϸ 
		if(adc10_data > 465) P1OUT &= ~0x01;		// P1.0 = 1 :: LED ON
		else P1OUT |= 0x01;				// P1.0 = 0 :: LED OFF
	}
}

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned dly;

	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000U; dly++) ;			// XTAL  ð 
	
// Rsel = 7, DCO = 7, MOD = 0, DCOR = 0 TA = 25 :: DCO ִ ļ (4.4 - 5.4Mhz)
// XTX  : Low Freqency
// DIVx : ACLK = LXFTCLK(32.768KHz)
// Register Select : 7
	BCSCTL1 = XT2OFF + RSEL2 + RSEL1 + RSEL0;
	DCOCTL = 0xe0;						// DCO Max Freqency
}

// ============================== ADC10  ==================================
// [μ] void
// ----------------------------------------------------------------------------
void adc10_set(void)
{
// Input Channel : a0
// ADC10 Clock divider : /4	
	ADC10CTL1 = INCH_0+ADC10DIV_3;				// A0 for ADC10CLK/4   
// SREFx     : VR+ = AVcc, VR- = AVss
// ADC10SHTx : 16 * ADC1-CLKs
// ADC10SR   : ~200ksps
// REF2.5V   : 1.5V
// REFON     : Reference off 
// ADC10ON   : ADC10 on
// ADC10IE   : interrupt enable
	ADC10CTL0 = ADC10SHT_2 + ADC10ON + ADC10IE;		// ADC10ON, interrupt enabled
// Analog Input Enable
// ADCAE0 - 7
	ADC10AE |= 0x01;					// P2.0 ADC option select 
}

// ============================== ADC10 interrupt =============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt (ADC10_VECTOR)ADC10_ISR(void)
{
	adc10_data = ADC10MEM;					// Move results, IFG is cleared
	adc10_int_flg = 1;					// a/d data flag on
}
