// ==================== MSP430F1xxx Ÿ̸_A0 ׽Ʈ α׷ =================
//  CPU : MSP430F1232
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : mspgcc+Dev-C++
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(3.6864MHz)
//            SMCLK: DCO(3.6864MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include <io.h>
#include <signal.h>
#include <iomacros.h>

//  
#define		DELTA_1	900					// DCO = DELATA_1 * 4096 = 3.6864MHz
#define		DELTA_2	250					// DCO = DELATA_2 * 4096 = 1.024000MHz
#define		DELTA_3	64					// DCO = DELATA_3 * 4096 = 0.262144MHz

#define		DELTA	DELTA_1					// DCO = 3.6864MHz

// Լ 
void cpu_setup(void);						// CPU ʱȭ
void Set_DCO(void);						// DCO 
void Set_TimerA0(void);						// Ÿ̸ A0 

//  

// ===============================  α׷ ==============================
// [μ]: void
// []: P1.0 : 10.036ms  
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();						// cpuʱȭ
	_EINT();						// Enable interrupts

	P1DIR = 0x01;						// Port1.0 Output
	while(1){
		_NOP();
	}
}

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned dly;
	
	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	
// XTX  : Low Freqency
// DIVx : ACLK(4.096Khz) = LXFTCLK(32.768KHz) / 8
	BCSCTL1 = XT2OFF | DIVA1 | DIVA0;
	for(dly = 0; dly < 0x4000U; dly++) ;			// XTAL  ð 

	Set_DCO();						// DCO 

// DIVx : ACLK = LXFTCLK(32.768KHz) / 1
	BCSCTL1 &= ~(DIVA1 | DIVA0);

	Set_TimerA0();						// Timer0 (10.036ms)
}

// =================================== DCO  ===============================
// [μ] void
// ----------------------------------------------------------------------------
void Set_DCO(void)
{
unsigned int Compare, Oldcapture = 0;

// CMx  : Capture on rising edge(01)
// CCISx: CCIxB(01)
// CAP  : Capture Mode(1)
	CCTL2 = CCIS0 + CM0 + CAP;				// Define CCR2, CAP, ACLK
// TASSELx : Timer Clock Source ACLK(01)
// TACLR : TimerA Clear
// MCx   : Continuos mode : The timer counts up to 0xffffh(10)
	TACTL = TASSEL1 + TACLR + MC1;				// SMCLK, continous mode
	while(1){
		while((CCTL2 & CCIFG) != CCIFG);		// Wait until capture occured!
		CCTL2 &= ~CCIFG;				// Capture occured, clear flag
		Compare = CCR2;					// Get current captured SMCLK
		Compare = Compare - Oldcapture;			// SMCLK difference
		Oldcapture = CCR2;				// Save current captured SMCLK
		if(DELTA == Compare){
			break;					// if equal, leave "while(1)"
		}
		else if(DELTA < Compare){			// DCO is too fast, slow it down
			DCOCTL--;
			if(DCOCTL == 0xFF){			// Did DCO role under?
				BCSCTL1--;			// Select next lower RSEL
			}
		}
		else{
			DCOCTL++;
			if(DCOCTL == 0x00){			// Did DCO role over?
				BCSCTL1++;                      // Select next higher RSEL
			}
		}
	}  
	CCTL2 = 0;                              		// Stop CCR2 function
	TACTL = 0;						// Stop Timer_A
}

// ================================== TimerA0  ============================
// [μ] void
// [] 3.6864Mhz / 37000 = 99.632Hz(10.036ms)
// ----------------------------------------------------------------------------
void Set_TimerA0(void)
{
// TASSELx : Timer Clock Source SMCLK(10)
// TACLR : TimerA Clear
// MCx   : Continuos mode : The timer counts up to 0xffffh(10)
	TACTL = TASSEL1 + TACLR + MC1;				// SMCLK, continous mode
// CCIE : Capture/Compare Interrupt enable
	CCTL0 = CCIE;						// CCR0 interrupt enabled
 	CCR0 = 37000;						// 10.036892ms
}

// ============================ Timer A0 interrupt ============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt (TIMERA0_VECTOR)Timer_A(void)
{
 	CCR0 += 37000;						// 10.036892ms
	P1OUT ^= 0x01;						// Toggle P1.0
}
